diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/tables/wblists.cpp libkdcraw/libkdcraw/libraw/src/tables/wblists.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/tables/wblists.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/tables/wblists.cpp	2022-11-07 07:46:31.738795008 +0300
@@ -0,0 +1,210 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/dcraw_defs.h"
+
+
+#define _ARR_SZ(a) (sizeof(a)/sizeof(a[0]))
+
+static const int _tagtype_dataunit_bytes [19] = {
+    1, 1, 1, 2, 4, 8, 1, 1, 2, 4, 8, 4, 8, 4, 2, 8, 8, 8, 8
+};
+
+libraw_static_table_t LibRaw::tagtype_dataunit_bytes(_tagtype_dataunit_bytes, _ARR_SZ(_tagtype_dataunit_bytes));
+
+static const int _Canon_wbi2std[] = { // Canon WB index to standard indexes
+//      std. number                wbi - Canon number
+    LIBRAW_WBI_Auto,             // 0
+    LIBRAW_WBI_Daylight,         // 1
+    LIBRAW_WBI_Cloudy,           // 2
+    LIBRAW_WBI_Tungsten,         // 3
+    LIBRAW_WBI_Fluorescent,      // 4
+    LIBRAW_WBI_Flash,            // 5
+    LIBRAW_WBI_Custom,           // 6
+    LIBRAW_WBI_BW,               // 7
+    LIBRAW_WBI_Shade,            // 8
+    LIBRAW_WBI_Kelvin,           // 9
+    LIBRAW_WBI_PC_Set1,          // 10
+    LIBRAW_WBI_PC_Set2,          // 11
+    LIBRAW_WBI_PC_Set3,          // 12
+    LIBRAW_WBI_Unknown,          // 13, unlucky number "13", not used
+    LIBRAW_WBI_FluorescentHigh,  // 14
+    LIBRAW_WBI_Custom1,          // 15
+    LIBRAW_WBI_Custom2,          // 16
+    LIBRAW_WBI_Underwater,       // 17, last one for older PowerShot models
+    LIBRAW_WBI_Custom3,          // 18
+    LIBRAW_WBI_Custom4,          // 19
+    LIBRAW_WBI_PC_Set4,          // 20
+    LIBRAW_WBI_PC_Set5,          // 21
+    LIBRAW_WBI_Unknown,          // 22
+    LIBRAW_WBI_Auto1             // 23
+};
+
+libraw_static_table_t LibRaw::Canon_wbi2std(_Canon_wbi2std, _ARR_SZ(_Canon_wbi2std));
+
+static const int _Canon_KeyIsZero_Len2048_linenums_2_StdWBi[] = { // Appendix A: G2, S30, S40; G3, G5, S45, S50
+  LIBRAW_WBI_Custom1,
+  LIBRAW_WBI_Custom2,
+  LIBRAW_WBI_Daylight,
+  LIBRAW_WBI_Cloudy,
+  LIBRAW_WBI_Tungsten,
+  LIBRAW_WBI_Fluorescent,
+  LIBRAW_WBI_Unknown, // ? FluorescentHigh, Shade, Custom, Kelvin
+  LIBRAW_WBI_Flash
+};
+
+libraw_static_table_t LibRaw::Canon_KeyIsZero_Len2048_linenums_2_StdWBi(_Canon_KeyIsZero_Len2048_linenums_2_StdWBi,
+    _ARR_SZ(_Canon_KeyIsZero_Len2048_linenums_2_StdWBi));
+
+static const int _Canon_KeyIs0x0410_Len3072_linenums_2_StdWBi[] = { // G6, S60, S70; offset +16
+  LIBRAW_WBI_Custom1,
+  LIBRAW_WBI_Custom2,
+  LIBRAW_WBI_Daylight,
+  LIBRAW_WBI_Cloudy,
+  LIBRAW_WBI_Tungsten,
+  LIBRAW_WBI_Fluorescent,
+  LIBRAW_WBI_FluorescentHigh, // LIBRAW_WBI_Unknown, // ? FluorescentHigh, Shade, Custom, Kelvin
+  LIBRAW_WBI_Unknown,
+  LIBRAW_WBI_Underwater, // LIBRAW_WBI_Unknown,
+  LIBRAW_WBI_Unknown,
+  LIBRAW_WBI_Flash
+};
+
+libraw_static_table_t LibRaw::Canon_KeyIs0x0410_Len3072_linenums_2_StdWBi(_Canon_KeyIs0x0410_Len3072_linenums_2_StdWBi,
+    _ARR_SZ(_Canon_KeyIs0x0410_Len3072_linenums_2_StdWBi));
+
+static const int _Canon_KeyIs0x0410_Len2048_linenums_2_StdWBi[] = { // Pro1; offset +8
+  LIBRAW_WBI_Custom1,
+  LIBRAW_WBI_Custom2,
+  LIBRAW_WBI_Daylight,
+  LIBRAW_WBI_Cloudy,
+  LIBRAW_WBI_Tungsten,
+  LIBRAW_WBI_Fluorescent,
+  LIBRAW_WBI_Unknown,
+  LIBRAW_WBI_Flash, // LIBRAW_WBI_Unknown,
+  LIBRAW_WBI_Unknown,
+  LIBRAW_WBI_Unknown,
+  LIBRAW_WBI_Unknown // LIBRAW_WBI_Flash
+};
+
+libraw_static_table_t LibRaw::Canon_KeyIs0x0410_Len2048_linenums_2_StdWBi(_Canon_KeyIs0x0410_Len2048_linenums_2_StdWBi,
+    _ARR_SZ(_Canon_KeyIs0x0410_Len2048_linenums_2_StdWBi));
+
+static const int _Canon_G9_linenums_2_StdWBi[] = {
+    LIBRAW_WBI_Auto,
+    LIBRAW_WBI_Daylight,
+    LIBRAW_WBI_Cloudy,
+    LIBRAW_WBI_Tungsten,
+    LIBRAW_WBI_Fluorescent,
+    LIBRAW_WBI_FluorescentHigh,
+    LIBRAW_WBI_Flash,
+    LIBRAW_WBI_Underwater,
+    LIBRAW_WBI_Custom1,
+    LIBRAW_WBI_Custom2
+};
+libraw_static_table_t LibRaw::Canon_G9_linenums_2_StdWBi(_Canon_G9_linenums_2_StdWBi, _ARR_SZ(_Canon_G9_linenums_2_StdWBi));
+
+static const int _Canon_D30_linenums_2_StdWBi[] = {
+    LIBRAW_WBI_Daylight,
+    LIBRAW_WBI_Cloudy,
+    LIBRAW_WBI_Tungsten,
+    LIBRAW_WBI_Fluorescent,
+    LIBRAW_WBI_Flash,
+    LIBRAW_WBI_Custom
+};
+libraw_static_table_t LibRaw::Canon_D30_linenums_2_StdWBi(_Canon_D30_linenums_2_StdWBi, _ARR_SZ(_Canon_D30_linenums_2_StdWBi));
+
+static const int _Fuji_wb_list1[] = {
+    LIBRAW_WBI_FineWeather, LIBRAW_WBI_Shade, LIBRAW_WBI_FL_D,
+    LIBRAW_WBI_FL_L,        LIBRAW_WBI_FL_W,  LIBRAW_WBI_Tungsten
+};
+libraw_static_table_t LibRaw::Fuji_wb_list1(_Fuji_wb_list1, _ARR_SZ(_Fuji_wb_list1));
+
+static const int _FujiCCT_K[31] = {
+    2500, 2550, 2650, 2700, 2800, 2850, 2950, 3000, 3100, 3200, 3300,
+    3400, 3600, 3700, 3800, 4000, 4200, 4300, 4500, 4800, 5000, 5300,
+    5600, 5900, 6300, 6700, 7100, 7700, 8300, 9100, 10000
+};
+libraw_static_table_t LibRaw::FujiCCT_K(_FujiCCT_K, _ARR_SZ(_FujiCCT_K));
+
+static const int _Fuji_wb_list2[] = {
+    LIBRAW_WBI_Auto,  0,  LIBRAW_WBI_Custom,   6,  LIBRAW_WBI_FineWeather, 1,
+    LIBRAW_WBI_Shade, 8,  LIBRAW_WBI_FL_D,     10, LIBRAW_WBI_FL_L,        11,
+    LIBRAW_WBI_FL_W,  12, LIBRAW_WBI_Tungsten, 2,  LIBRAW_WBI_Underwater,  35,
+    LIBRAW_WBI_Ill_A, 82, LIBRAW_WBI_D65,      83
+};
+libraw_static_table_t LibRaw::Fuji_wb_list2(_Fuji_wb_list2, _ARR_SZ(_Fuji_wb_list2));
+
+static const int _Pentax_wb_list1[] = {
+    LIBRAW_WBI_Daylight, LIBRAW_WBI_Shade,
+    LIBRAW_WBI_Cloudy,   LIBRAW_WBI_Tungsten,
+    LIBRAW_WBI_FL_D,     LIBRAW_WBI_FL_N,
+    LIBRAW_WBI_FL_W,     LIBRAW_WBI_Flash
+};
+libraw_static_table_t LibRaw::Pentax_wb_list1(_Pentax_wb_list1, _ARR_SZ(_Pentax_wb_list1));
+
+static const int _Pentax_wb_list2[] = {
+    LIBRAW_WBI_Daylight, LIBRAW_WBI_Shade, LIBRAW_WBI_Cloudy,
+    LIBRAW_WBI_Tungsten, LIBRAW_WBI_FL_D,  LIBRAW_WBI_FL_N,
+    LIBRAW_WBI_FL_W,     LIBRAW_WBI_Flash, LIBRAW_WBI_FL_L
+};
+libraw_static_table_t LibRaw::Pentax_wb_list2(_Pentax_wb_list2, _ARR_SZ(_Pentax_wb_list2));
+
+
+static const int _Oly_wb_list1[] = {
+    LIBRAW_WBI_Shade,    LIBRAW_WBI_Cloudy, LIBRAW_WBI_FineWeather,
+    LIBRAW_WBI_Tungsten, LIBRAW_WBI_Sunset, LIBRAW_WBI_FL_D,
+    LIBRAW_WBI_FL_N,     LIBRAW_WBI_FL_W,   LIBRAW_WBI_FL_WW
+};
+libraw_static_table_t LibRaw::Oly_wb_list1(_Oly_wb_list1, _ARR_SZ(_Oly_wb_list1));
+
+static const int _Oly_wb_list2[] = {
+    LIBRAW_WBI_Auto, 0,
+    LIBRAW_WBI_Tungsten, 3000,
+    0x100, 3300,
+    0x100, 3600,
+    0x100, 3900,
+    LIBRAW_WBI_FL_W, 4000,
+    0x100, 4300,
+    LIBRAW_WBI_FL_D, 4500,
+    0x100, 4800,
+    LIBRAW_WBI_FineWeather, 5300,
+    LIBRAW_WBI_Cloudy, 6000,
+    LIBRAW_WBI_FL_N, 6600,
+    LIBRAW_WBI_Shade, 7500,
+    LIBRAW_WBI_Custom1, 0,
+    LIBRAW_WBI_Custom2, 0,
+    LIBRAW_WBI_Custom3, 0,
+    LIBRAW_WBI_Custom4, 0
+};
+libraw_static_table_t LibRaw::Oly_wb_list2(_Oly_wb_list2, _ARR_SZ(_Oly_wb_list2));
+
+static const int _Sony_SRF_wb_list[] = {
+    LIBRAW_WBI_Daylight, LIBRAW_WBI_Cloudy, LIBRAW_WBI_Fluorescent,
+    LIBRAW_WBI_Tungsten, LIBRAW_WBI_Flash
+};
+libraw_static_table_t LibRaw::Sony_SRF_wb_list(_Sony_SRF_wb_list, _ARR_SZ(_Sony_SRF_wb_list));
+
+static const int _Sony_SR2_wb_list[] = {
+    LIBRAW_WBI_Daylight, LIBRAW_WBI_Cloudy, LIBRAW_WBI_Tungsten, LIBRAW_WBI_Flash,
+    4500, LIBRAW_WBI_Unknown, LIBRAW_WBI_Fluorescent
+};
+libraw_static_table_t LibRaw::Sony_SR2_wb_list(_Sony_SR2_wb_list, _ARR_SZ(_Sony_SR2_wb_list));
+
+static const int _Sony_SR2_wb_list1[] = {
+    LIBRAW_WBI_Daylight, LIBRAW_WBI_Cloudy, LIBRAW_WBI_Tungsten, LIBRAW_WBI_Flash,
+    4500, LIBRAW_WBI_Shade, LIBRAW_WBI_FL_W, LIBRAW_WBI_FL_N, LIBRAW_WBI_FL_D,
+    LIBRAW_WBI_FL_L, 8500, 6000, 3200, 2500
+};
+libraw_static_table_t LibRaw::Sony_SR2_wb_list1(_Sony_SR2_wb_list1, _ARR_SZ(_Sony_SR2_wb_list1));
\ No newline at end of file
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/utils/curves.cpp libkdcraw/libkdcraw/libraw/src/utils/curves.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/utils/curves.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/utils/curves.cpp	2022-11-07 07:46:31.738795008 +0300
@@ -0,0 +1,151 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw uses code from dcraw.c -- Dave Coffin's raw photo decoder,
+ dcraw.c is copyright 1997-2018 by Dave Coffin, dcoffin a cybercom o net.
+ LibRaw do not use RESTRICTED code from dcraw.c
+
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/dcraw_defs.h"
+
+void LibRaw::cubic_spline(const int *x_, const int *y_, const int len)
+{
+  float **A, *b, *c, *d, *x, *y;
+  int i, j;
+
+  A = (float **)calloc(((2 * len + 4) * sizeof **A + sizeof *A), 2 * len);
+  if (!A)
+    return;
+  A[0] = (float *)(A + 2 * len);
+  for (i = 1; i < 2 * len; i++)
+    A[i] = A[0] + 2 * len * i;
+  y = len + (x = i + (d = i + (c = i + (b = A[0] + i * i))));
+  for (i = 0; i < len; i++)
+  {
+    x[i] = x_[i] / 65535.0;
+    y[i] = y_[i] / 65535.0;
+  }
+  for (i = len - 1; i > 0; i--)
+  {
+    b[i] = (y[i] - y[i - 1]) / (x[i] - x[i - 1]);
+    d[i - 1] = x[i] - x[i - 1];
+  }
+  for (i = 1; i < len - 1; i++)
+  {
+    A[i][i] = 2 * (d[i - 1] + d[i]);
+    if (i > 1)
+    {
+      A[i][i - 1] = d[i - 1];
+      A[i - 1][i] = d[i - 1];
+    }
+    A[i][len - 1] = 6 * (b[i + 1] - b[i]);
+  }
+  for (i = 1; i < len - 2; i++)
+  {
+    float v = A[i + 1][i] / A[i][i];
+    for (j = 1; j <= len - 1; j++)
+      A[i + 1][j] -= v * A[i][j];
+  }
+  for (i = len - 2; i > 0; i--)
+  {
+    float acc = 0;
+    for (j = i; j <= len - 2; j++)
+      acc += A[i][j] * c[j];
+    c[i] = (A[i][len - 1] - acc) / A[i][i];
+  }
+  for (i = 0; i < 0x10000; i++)
+  {
+    float x_out = (float)(i / 65535.0);
+    float y_out = 0;
+    for (j = 0; j < len - 1; j++)
+    {
+      if (x[j] <= x_out && x_out <= x[j + 1])
+      {
+        float v = x_out - x[j];
+        y_out = y[j] +
+                ((y[j + 1] - y[j]) / d[j] -
+                 (2 * d[j] * c[j] + c[j + 1] * d[j]) / 6) *
+                    v +
+                (c[j] * 0.5) * v * v +
+                ((c[j + 1] - c[j]) / (6 * d[j])) * v * v * v;
+      }
+    }
+    curve[i] = y_out < 0.0
+                   ? 0
+                   : (y_out >= 1.0 ? 65535 : (ushort)(y_out * 65535.0 + 0.5));
+  }
+  free(A);
+}
+void LibRaw::gamma_curve(double pwr, double ts, int mode, int imax)
+{
+  int i;
+  double g[6], bnd[2] = {0, 0}, r;
+
+  g[0] = pwr;
+  g[1] = ts;
+  g[2] = g[3] = g[4] = 0;
+  bnd[g[1] >= 1] = 1;
+  if (g[1] && (g[1] - 1) * (g[0] - 1) <= 0)
+  {
+    for (i = 0; i < 48; i++)
+    {
+      g[2] = (bnd[0] + bnd[1]) / 2;
+      if (g[0])
+        bnd[(pow(g[2] / g[1], -g[0]) - 1) / g[0] - 1 / g[2] > -1] = g[2];
+      else
+        bnd[g[2] / exp(1 - 1 / g[2]) < g[1]] = g[2];
+    }
+    g[3] = g[2] / g[1];
+    if (g[0])
+      g[4] = g[2] * (1 / g[0] - 1);
+  }
+  if (g[0])
+    g[5] = 1 / (g[1] * SQR(g[3]) / 2 - g[4] * (1 - g[3]) +
+                (1 - pow(g[3], 1 + g[0])) * (1 + g[4]) / (1 + g[0])) -
+           1;
+  else
+    g[5] = 1 / (g[1] * SQR(g[3]) / 2 + 1 - g[2] - g[3] -
+                g[2] * g[3] * (log(g[3]) - 1)) -
+           1;
+  if (!mode--)
+  {
+    memcpy(gamm, g, sizeof gamm);
+    return;
+  }
+  for (i = 0; i < 0x10000; i++)
+  {
+    curve[i] = 0xffff;
+    if ((r = (double)i / imax) < 1)
+      curve[i] =
+          0x10000 *
+          (mode ? (r < g[3] ? r * g[1]
+                            : (g[0] ? pow(r, g[0]) * (1 + g[4]) - g[4]
+                                    : log(r) * g[2] + 1))
+                : (r < g[2] ? r / g[1]
+                            : (g[0] ? pow((r + g[4]) / (1 + g[4]), 1 / g[0])
+                                    : exp((r - 1) / g[2]))));
+  }
+}
+
+void LibRaw::linear_table(unsigned len)
+{
+  int i;
+  if (len > 0x10000)
+    len = 0x10000;
+  else if (len < 1)
+    return;
+  read_shorts(curve, len);
+  for (i = len; i < 0x10000; i++)
+    curve[i] = curve[i - 1];
+  maximum = curve[len < 0x1000 ? 0xfff : len - 1];
+}
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/utils/decoder_info.cpp libkdcraw/libkdcraw/libraw/src/utils/decoder_info.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/utils/decoder_info.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/utils/decoder_info.cpp	2022-11-07 07:46:31.738795008 +0300
@@ -0,0 +1,389 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+#include "../../internal/libraw_cxx_defs.h"
+
+const char *LibRaw::unpack_function_name()
+{
+  libraw_decoder_info_t decoder_info;
+  get_decoder_info(&decoder_info);
+  return decoder_info.decoder_name;
+}
+
+int LibRaw::get_decoder_info(libraw_decoder_info_t *d_info)
+{
+  if (!d_info)
+    return LIBRAW_UNSPECIFIED_ERROR;
+  d_info->decoder_name = 0;
+  d_info->decoder_flags = 0;
+  if (!load_raw)
+    return LIBRAW_OUT_OF_ORDER_CALL;
+
+  // dcraw.c names order
+  if (load_raw == &LibRaw::android_tight_load_raw)
+  {
+    d_info->decoder_name = "android_tight_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::android_loose_load_raw)
+  {
+    d_info->decoder_name = "android_loose_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::float_dng_load_raw_placeholder)
+  {
+    d_info->decoder_name = "float_dng_load_raw_placeholder()";
+  }
+  else if (load_raw == &LibRaw::vc5_dng_load_raw_placeholder)
+  {
+      d_info->decoder_name = "vc5_dng_load_raw_placeholder()";
+  }
+  else if (load_raw == &LibRaw::canon_600_load_raw)
+  {
+    d_info->decoder_name = "canon_600_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::fuji_compressed_load_raw)
+  {
+    d_info->decoder_name = "fuji_compressed_load_raw()";
+  }
+  else if (load_raw == &LibRaw::fuji_14bit_load_raw)
+  {
+    d_info->decoder_name = "fuji_14bit_load_raw()";
+  }
+  else if (load_raw == &LibRaw::canon_load_raw)
+  {
+    d_info->decoder_name = "canon_load_raw()";
+  }
+  else if (load_raw == &LibRaw::lossless_jpeg_load_raw)
+  {
+    d_info->decoder_name = "lossless_jpeg_load_raw()";
+    d_info->decoder_flags =
+        LIBRAW_DECODER_HASCURVE | LIBRAW_DECODER_TRYRAWSPEED;
+  }
+  else if (load_raw == &LibRaw::canon_sraw_load_raw)
+  {
+    d_info->decoder_name = "canon_sraw_load_raw()";
+    // d_info->decoder_flags = LIBRAW_DECODER_TRYRAWSPEED;
+  }
+  else if (load_raw == &LibRaw::crxLoadRaw)
+  {
+    d_info->decoder_name = "crxLoadRaw()";
+  }
+  else if (load_raw == &LibRaw::lossless_dng_load_raw)
+  {
+    d_info->decoder_name = "lossless_dng_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_HASCURVE |
+                            LIBRAW_DECODER_TRYRAWSPEED |
+                            LIBRAW_DECODER_ADOBECOPYPIXEL;
+  }
+  else if (load_raw == &LibRaw::packed_dng_load_raw)
+  {
+    d_info->decoder_name = "packed_dng_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_HASCURVE |
+                            LIBRAW_DECODER_TRYRAWSPEED |
+                            LIBRAW_DECODER_ADOBECOPYPIXEL;
+  }
+  else if (load_raw == &LibRaw::pentax_load_raw)
+  {
+    d_info->decoder_name = "pentax_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_TRYRAWSPEED;
+  }
+  else if (load_raw == &LibRaw::nikon_load_raw)
+  {
+    d_info->decoder_name = "nikon_load_raw()";
+    d_info->decoder_flags =
+        LIBRAW_DECODER_TRYRAWSPEED | LIBRAW_DECODER_HASCURVE;
+  }
+  else if (load_raw == &LibRaw::nikon_coolscan_load_raw)
+  {
+    d_info->decoder_name = "nikon_coolscan_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::nikon_load_sraw)
+  {
+    d_info->decoder_name = "nikon_load_sraw()";
+    d_info->decoder_flags = LIBRAW_DECODER_HASCURVE | LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::nikon_yuv_load_raw)
+  {
+    d_info->decoder_name = "nikon_load_yuv_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_HASCURVE | LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::rollei_load_raw)
+  {
+    // UNTESTED
+    d_info->decoder_name = "rollei_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::phase_one_load_raw)
+  {
+    d_info->decoder_name = "phase_one_load_raw()";
+  }
+  else if (load_raw == &LibRaw::phase_one_load_raw_c)
+  {
+    d_info->decoder_name = "phase_one_load_raw_c()";
+  }
+  else if (load_raw == &LibRaw::hasselblad_load_raw)
+  {
+    d_info->decoder_name = "hasselblad_load_raw()";
+  }
+  else if (load_raw == &LibRaw::leaf_hdr_load_raw)
+  {
+    d_info->decoder_name = "leaf_hdr_load_raw()";
+  }
+  else if (load_raw == &LibRaw::unpacked_load_raw)
+  {
+    d_info->decoder_name = "unpacked_load_raw()";
+	d_info->decoder_flags = LIBRAW_DECODER_FLATDATA;
+  }
+  else if (load_raw == &LibRaw::unpacked_load_raw_reversed)
+  {
+    d_info->decoder_name = "unpacked_load_raw_reversed()";
+    d_info->decoder_flags = LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::sinar_4shot_load_raw)
+  {
+    // UNTESTED
+    d_info->decoder_name = "sinar_4shot_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_SINAR4SHOT;
+  }
+  else if (load_raw == &LibRaw::imacon_full_load_raw)
+  {
+    d_info->decoder_name = "imacon_full_load_raw()";
+  }
+  else if (load_raw == &LibRaw::hasselblad_full_load_raw)
+  {
+    d_info->decoder_name = "hasselblad_full_load_raw()";
+  }
+  else if (load_raw == &LibRaw::packed_load_raw)
+  {
+    d_info->decoder_name = "packed_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_TRYRAWSPEED;
+  }
+  else if (load_raw == &LibRaw::broadcom_load_raw)
+  {
+    // UNTESTED
+    d_info->decoder_name = "broadcom_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::nokia_load_raw)
+  {
+    // UNTESTED
+    d_info->decoder_name = "nokia_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::canon_rmf_load_raw)
+  {
+    // UNTESTED
+    d_info->decoder_name = "canon_rmf_load_raw()";
+  }
+  else if (load_raw == &LibRaw::panasonic_load_raw)
+  {
+    d_info->decoder_name = "panasonic_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_TRYRAWSPEED;
+  }
+  else if (load_raw == &LibRaw::panasonicC6_load_raw)
+  {
+    d_info->decoder_name = "panasonicC6_load_raw()";
+  }
+  else if (load_raw == &LibRaw::panasonicC7_load_raw)
+  {
+    d_info->decoder_name = "panasonicC7_load_raw()";
+  }
+  else if (load_raw == &LibRaw::olympus_load_raw)
+  {
+    d_info->decoder_name = "olympus_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_TRYRAWSPEED;
+  }
+  else if (load_raw == &LibRaw::minolta_rd175_load_raw)
+  {
+    // UNTESTED
+    d_info->decoder_name = "minolta_rd175_load_raw()";
+  }
+  else if (load_raw == &LibRaw::quicktake_100_load_raw)
+  {
+    // UNTESTED
+    d_info->decoder_name = "quicktake_100_load_raw()";
+  }
+  else if (load_raw == &LibRaw::kodak_radc_load_raw)
+  {
+    d_info->decoder_name = "kodak_radc_load_raw()";
+  }
+  else if (load_raw == &LibRaw::kodak_jpeg_load_raw)
+  {
+    // UNTESTED + RBAYER
+    d_info->decoder_name = "kodak_jpeg_load_raw()";
+  }
+  else if (load_raw == &LibRaw::lossy_dng_load_raw)
+  {
+    // Check rbayer
+    d_info->decoder_name = "lossy_dng_load_raw()";
+    d_info->decoder_flags =
+        LIBRAW_DECODER_TRYRAWSPEED | LIBRAW_DECODER_HASCURVE;
+  }
+  else if (load_raw == &LibRaw::kodak_dc120_load_raw)
+  {
+    d_info->decoder_name = "kodak_dc120_load_raw()";
+  }
+  else if (load_raw == &LibRaw::eight_bit_load_raw)
+  {
+    d_info->decoder_name = "eight_bit_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_HASCURVE | LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::kodak_c330_load_raw)
+  {
+    d_info->decoder_name = "kodak_yrgb_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_HASCURVE | LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::kodak_c603_load_raw)
+  {
+    d_info->decoder_name = "kodak_yrgb_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_HASCURVE | LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::kodak_262_load_raw)
+  {
+    d_info->decoder_name = "kodak_262_load_raw()"; // UNTESTED!
+    d_info->decoder_flags = LIBRAW_DECODER_HASCURVE | LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::kodak_65000_load_raw)
+  {
+    d_info->decoder_name = "kodak_65000_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_HASCURVE;
+  }
+  else if (load_raw == &LibRaw::kodak_ycbcr_load_raw)
+  {
+    // UNTESTED
+    d_info->decoder_name = "kodak_ycbcr_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_HASCURVE | LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::kodak_rgb_load_raw)
+  {
+    // UNTESTED
+    d_info->decoder_name = "kodak_rgb_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::sony_load_raw)
+  {
+    d_info->decoder_name = "sony_load_raw()";
+  }
+  else if (load_raw == &LibRaw::sony_arw_load_raw)
+  {
+    d_info->decoder_name = "sony_arw_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_TRYRAWSPEED;
+  }
+  else if (load_raw == &LibRaw::sony_arw2_load_raw)
+  {
+    d_info->decoder_name = "sony_arw2_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_HASCURVE |
+                            LIBRAW_DECODER_TRYRAWSPEED |
+                            LIBRAW_DECODER_SONYARW2;
+  }
+  else if (load_raw == &LibRaw::sony_arq_load_raw)
+  {
+    d_info->decoder_name = "sony_arq_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_LEGACY_WITH_MARGINS | LIBRAW_DECODER_FLATDATA | LIBRAW_DECODER_FLAT_BG2_SWAPPED;
+  }
+  else if (load_raw == &LibRaw::samsung_load_raw)
+  {
+    d_info->decoder_name = "samsung_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_TRYRAWSPEED;
+  }
+  else if (load_raw == &LibRaw::samsung2_load_raw)
+  {
+    d_info->decoder_name = "samsung2_load_raw()";
+  }
+  else if (load_raw == &LibRaw::samsung3_load_raw)
+  {
+    d_info->decoder_name = "samsung3_load_raw()";
+  }
+  else if (load_raw == &LibRaw::smal_v6_load_raw)
+  {
+    // UNTESTED
+    d_info->decoder_name = "smal_v6_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::smal_v9_load_raw)
+  {
+    // UNTESTED
+    d_info->decoder_name = "smal_v9_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_FIXEDMAXC;
+  }
+  else if (load_raw == &LibRaw::redcine_load_raw)
+  {
+    d_info->decoder_name = "redcine_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_HASCURVE;
+  }
+  else if (load_raw == &LibRaw::x3f_load_raw)
+  {
+    d_info->decoder_name = "x3f_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_OWNALLOC | LIBRAW_DECODER_FIXEDMAXC |
+                            LIBRAW_DECODER_LEGACY_WITH_MARGINS;
+  }
+  else if (load_raw == &LibRaw::pentax_4shot_load_raw)
+  {
+    d_info->decoder_name = "pentax_4shot_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_OWNALLOC;
+  }
+  else if (load_raw == &LibRaw::deflate_dng_load_raw)
+  {
+    d_info->decoder_name = "deflate_dng_load_raw()";
+    d_info->decoder_flags = LIBRAW_DECODER_OWNALLOC;
+  }
+  else if (load_raw == &LibRaw::nikon_load_striped_packed_raw)
+  {
+    d_info->decoder_name = "nikon_load_striped_packed_raw()";
+  }
+  else if (load_raw == &LibRaw::nikon_load_padded_packed_raw)
+  {
+    d_info->decoder_name = "nikon_load_padded_packed_raw()";
+  }
+  else if (load_raw == &LibRaw::nikon_14bit_load_raw)
+  {
+    d_info->decoder_name = "nikon_14bit_load_raw()";
+  }
+  /* -- added 07/02/18 -- */
+  else if (load_raw == &LibRaw::unpacked_load_raw_fuji_f700s20)
+  {
+    d_info->decoder_name = "unpacked_load_raw_fuji_f700s20()";
+  }
+  else if (load_raw == &LibRaw::unpacked_load_raw_FujiDBP)
+  {
+    d_info->decoder_name = "unpacked_load_raw_FujiDBP()";
+  }
+#ifdef USE_6BY9RPI
+  else if (load_raw == &LibRaw::rpi_load_raw8)
+  {
+	d_info->decoder_name = "rpi_load_raw8";
+  }
+  else if (load_raw == &LibRaw::rpi_load_raw12)
+  {
+	d_info->decoder_name = "rpi_load_raw12";
+  }
+  else if (load_raw == &LibRaw::rpi_load_raw14)
+  {
+	d_info->decoder_name = "rpi_load_raw14";
+  }
+  else if (load_raw == &LibRaw::rpi_load_raw16)
+  {
+	d_info->decoder_name = "rpi_load_raw16";
+  }
+#endif
+  else
+  {
+    d_info->decoder_name = "Unknown unpack function";
+    d_info->decoder_flags = LIBRAW_DECODER_NOTSET;
+  }
+  return LIBRAW_SUCCESS;
+}
